[reset]

dim infoB$(10, 5)
dim infoH$(10, 5)
dim infoM$(10, 5)
dim infoS$(10, 5)

files DefaultDir$, "\Settings.txt", infoS$() 'Vi checker om filen "Settings.txt" findes - ellers vlger vi min default
if val(infoS$(0,0)) > 0 then

Points = 0
Erase = 0
UseModel = 0
WorkBackg = 0
Preview = 0
CuBack = 0

open "Settings.txt" for input as #s
input #s, WhiteGrid
input #s, NoGrid
input #s, Snap
input #s, Snap2
input #s, CenterX
input #s, CenterY
input #s, LineCol$
input #s, BackCol$
close #s

else

Points = 0
Erase = 0
UseModel = 0
WorkBackg = 0
Preview = 0
WhiteGrid = 0
NoGrid = 0
Snap = 0
Snap2 = 1
LineCol$ = "red"
BackCol$ = "darkgray"
end if

UpperLeftX = 0 'Til brug p andre pcer med hjere skrmoplsning
UpperLeftY = 0

if DisplayHeight > 1000 then 'afrund decimal til 0.125-multiplum, s Snap virker
WindowWidth = 1280
WindowHeight = 960
WF = 1.25
HF = 1.25
Font0 = 10
Font1 = 12
Font2 = 14
else
WindowWidth = 1024
WindowHeight = 768
WF = 1
HF = 1
Font0 = 9
Font1 = 11
Font2 = 12
end if

DIM XandY (500,3) ' array til at holde de klikkede X- og Y-vrdier
    XandY (0,3) = 1
DIM Background (500,3) 'array til at holde tidligere shapes brugt som baggrund for ny tegning
    Background (0,3) = 1

nomainwin

[undo1]

open "PointWriter 1.5 for POV-Ray by Christian Nevado" for graphics_nf_nsb as #grid
#grid, "trapclose [quit]"

[drawgrid]

print #grid, "setfocus"
scan

#grid, "when characterInput [letter]"

[background]   'Tilfjet label for at bevare Model background ved brug af Write

if NoGrid = 1 then
#grid, "cls"
end if

if UseModel=1 then
[loadModel]
loadbmp "model", Bitmap$ 
#grid, "backcolor white ; background model"
#grid, "drawsprites"
end if

if NoGrid = 1 then
goto [skipgrid]
end if

gosub [gridcolor]

#grid, "size 4 ; color ";GridCol$;" ; up ; place ";50*WF+400*CenterY*WF;" ";25*HF;" ; down ; line ";50*WF+400*CenterY*WF;" ";25*HF;" ";50*WF+400*CenterY*WF;" ";675*HF; 'Y-akse
#grid, "size 4 ; color ";GridCol$;" ; up ; place ";25*WF;" ";650*HF-300*CenterX*HF;" ; down ; line ";25*WF;" ";650*HF-300*CenterX*HF;" ";1000*WF;" ";650*HF-300*CenterX*HF; 'X-akse

if WF = 1.25 then
for DashY = 1 to 13 'Vandrette markeringer langs y
#grid, "size 2 ; color ";GridCol$;" ; up ; place ";25*WF;" ";DashY*50*HF;" ; down ; line ";25*WF;" ";DashY*50*HF;" ";1000*WF;" ";DashY*50*HF;'3
#grid, "size 1 ; color ";GridCol$;" ; up ; place ";25*WF;" ";DashY*50*HF-10*HF;" ; down ; line ";25*WF;" ";DashY*50*HF-10*HF;" ";1000*WF;" ";DashY*50*HF-10*HF; 'Kvarte enheder
#grid, "size 1 ; color ";GridCol$;" ; up ; place ";25*WF;" ";DashY*50*HF-20*HF;" ; down ; line ";25*WF;" ";DashY*50*HF-20*HF;" ";1000*WF;" ";DashY*50*HF-20*HF; 'Halve enheder
if DashY > 1 then
#grid, "size 1 ; color ";GridCol$;" ; up ; place ";25*WF;" ";DashY*50*HF-30*HF;" ; down ; line ";25*WF;" ";DashY*50*HF-30*HF;" ";1000*WF;" ";DashY*50*HF-30*HF; 'kvarte enheder
#grid, "size 1 ; color ";GridCol$;" ; up ; place ";25*WF;" ";DashY*50*HF-40*HF;" ; down ; line ";25*WF;" ";DashY*50*HF-40*HF;" ";1000*WF;" ";DashY*50*HF-40*HF; 'kvarte enheder
end if
#grid, "backcolor white ; font Arial 15 ; color black ; up ; place ";10*WF+400*CenterY*WF;" ";DashY*50*HF;" ; down ;\ ";13-6*CenterX-DashY;
next DashY
else
for DashY = 1 to 13 'Vandrette markeringer langs y
#grid, "size 2 ; color ";GridCol$;" ; up ; place ";25;" ";DashY*50;" ; down ; line ";25;" ";DashY*50;" ";1000;" ";DashY*50;'3
#grid, "size 1 ; color ";GridCol$;" ; up ; place ";25;" ";DashY*50-12.5;" ; down ; line ";25;" ";DashY*50-12.5;" ";1000;" ";DashY*50-12.5; 'Kvarte enheder
#grid, "size 1 ; color ";GridCol$;" ; up ; place ";25;" ";DashY*50-25;" ; down ; line ";25;" ";DashY*50-25;" ";1000;" ";DashY*50-25; 'Halve enheder
if DashY > 1 then
#grid, "size 1 ; color ";GridCol$;" ; up ; place ";25;" ";DashY*50-37.5;" ; down ; line ";25;" ";DashY*50-37.5;" ";1000;" ";DashY*50-37.5; 'kvarte enheder
end if
#grid, "backcolor white ; font Arial 15 ; color black ; up ; place ";10+400*CenterY;" ";DashY*50;" ; down ;\ ";13-6*CenterX-DashY;
next DashY
end if

if WF = 1.25 then
#grid, "size 2 ; color ";GridCol$;" ; up ; place ";50*WF;" ";25*HF;" ; down ; line ";50*WF;" ";25*HF;" ";50*WF;" ";675*HF;'3
for DashX = 1 to 17 'Lodrette markeringer langs x
#grid, "size 2 ; color ";GridCol$;" ; up ; place ";(DashX+1)*50*WF;" ";25*HF;" ; down ; line ";(DashX+1)*50*WF;" ";25*HF;" ";(DashX+1)*50*WF;" ";675*HF;'3
#grid, "size 1 ; color ";GridCol$;" ; up ; place ";(DashX+1)*50*WF-10*WF;" ";25*HF;" ; down ; line ";(DashX+1)*50*WF-10*WF;" ";25*HF;" ";(DashX+1)*50*WF-10*WF;" ";675*HF; 'Kvarte enheder
#grid, "size 1 ; color ";GridCol$;" ; up ; place ";(DashX+1)*50*WF-20*WF;" ";25*HF;" ; down ; line ";(DashX+1)*50*WF-20*WF;" ";25*HF;" ";(DashX+1)*50*WF-20*WF;" ";675*HF; 'Halve enheder
#grid, "size 1 ; color ";GridCol$;" ; up ; place ";(DashX+1)*50*WF-30*WF;" ";25*HF;" ; down ; line ";(DashX+1)*50*WF-30*WF;" ";25*HF;" ";(DashX+1)*50*WF-30*WF;" ";675*HF; 'Kvarte enheder
#grid, "size 1 ; color ";GridCol$;" ; up ; place ";(DashX+1)*50*WF-40*WF;" ";25*HF;" ; down ; line ";(DashX+1)*50*WF-40*WF;" ";25*HF;" ";(DashX+1)*50*WF-40*WF;" ";675*HF; 'Kvarte enheder
#grid, "backcolor white ; font Arial 15 ; color black ; up ; place ";(DashX-0.2)*50*WF;" ";700*HF-300*CenterX*HF;" ; down ;\ ";DashX-8*CenterY-1;
next DashX
else
#grid, "size 2 ; color ";GridCol$;" ; up ; place ";50*WF;" ";25*HF;" ; down ; line ";50*WF;" ";25*HF;" ";50*WF;" ";675*HF;'3
for DashX = 1 to 17 'Lodrette markeringer langs x
#grid, "size 2 ; color ";GridCol$;" ; up ; place ";(DashX+1)*50;" ";25;" ; down ; line ";(DashX+1)*50;" ";25;" ";(DashX+1)*50;" ";675;'3
#grid, "size 1 ; color ";GridCol$;" ; up ; place ";(DashX+1)*50-12.5;" ";25;" ; down ; line ";(DashX+1)*50-12.5;" ";25;" ";(DashX+1)*50-12.5;" ";675; 'Kvarte enheder
#grid, "size 1 ; color ";GridCol$;" ; up ; place ";(DashX+1)*50-25;" ";25;" ; down ; line ";(DashX+1)*50-25;" ";25;" ";(DashX+1)*50-25;" ";675; 'Halve enheder
#grid, "size 1 ; color ";GridCol$;" ; up ; place ";(DashX+1)*50-37.5;" ";25;" ; down ; line ";(DashX+1)*50-37.5;" ";25;" ";(DashX+1)*50-37.5;" ";675; 'Kvarte enheder
#grid, "backcolor white ; font Arial 15 ; color black ; up ; place ";(DashX-0.2)*50;" ";700-300*CenterX;" ; down ;\ ";DashX-8*CenterY-1;
next DashX
end if

[skipgrid]
#grid, "font Arial ";Font0;" ; backcolor white ; color black ; place ";20*WF;" ";18*HF;" ; down ;\ Press arrow key between clicks for vertical or horizontal lines"
#grid, "size 1 ; font Arial ";Font2;" bold ; color blue ; backcolor white ; up ; place ";900*WF;" ";25*HF;" ; down ; boxfilled ";1000*WF;" ";100*HF;" ; place ";905*WF;" ";45*HF;" ;\ PointWriter"
#grid, "up ; place ";900*WF;" ";65*HF;" ;\ for POV-Ray"
#grid, "backcolor white ; place ";1003*WF;" ";85*HF;" ;\h"
#grid, "font Arial ";Font2;" bold ; place ";910*WF;" ";90*HF;" ;\ ";Points;"  /  ";500-Points   'FR: #grid, "font Arial ";Font2;" bold ; place ";915*WF;" ";90*HF;" ;\ Left: ";500-Points
#grid, "color black ; backcolor cyan ; up ; place ";900*WF;" ";100*HF;" ; down ; boxfilled ";1000*WF;" ";125*HF;" ; place ";925*WF;" ";120*HF;" ;\ New"
#grid, "backcolor white ; place ";1003*WF;" ";120*HF;" ;\n"
#grid, "backcolor yellow ; up ; place ";900*WF;" ";125*HF;" ; down ; boxfilled ";1000*WF;" ";150*HF;" ; place ";925*WF;" ";145*HF;" ;\ Undo"
#grid, "backcolor white ; place ";1003*WF;" ";145*HF;" ;\z"
#grid, "backcolor yellow ; up ; place ";900*WF;" ";150*HF;" ; down ; boxfilled ";1000*WF;" ";175*HF;" ; place ";935*WF;" ";170*HF;" ;\Edit"
#grid, "backcolor white ; place ";1003*WF;" ";170*HF;" ;\e"
#grid, "backcolor white ; up ; place ";900*WF;" ";175*HF;" ; down ; boxfilled ";1000*WF;" ";200*HF;" ; place ";915*WF;" ";195*HF;" ;\ Center X"
#grid, "backcolor white ; place ";1003*WF;" ";195*HF;" ;\x"
#grid, "backcolor white ; up ; place ";900*WF;" ";200*HF;" ; down ; boxfilled ";1000*WF;" ";225*HF;" ; place ";915*WF;" ";220*HF;" ;\ Center Y"
#grid, "backcolor white ; place ";1003*WF;" ";220*HF;" ;\y"
#grid, "backcolor lightgray ; up ; place ";900*WF;" ";225*HF;" ; down ; boxfilled ";1000*WF;" ";250*HF;" ; place ";905*WF;" ";245*HF;" ;\Model .bmp"
#grid, "backcolor white ; place ";1003*WF;" ";245*HF;" ;\m"
#grid, "backcolor lightgray ; up ; place ";900*WF;" ";250*HF;" ; down ; boxfilled ";1000*WF;" ";275*HF;" ; color white ; place ";905*WF;" ";268*HF;" ;\ White"
#grid, "color black ; up ; place ";955*WF;" ";268*HF;" ;\ grid"
#grid, "backcolor white ; place ";1003*WF;" ";268*HF;" ;\w"
#grid, "backcolor lightgray ; up ; place ";900*WF;" ";275*HF;" ; down ; boxfilled ";1000*WF;" ";300*HF;" ; place ";915*WF;" ";293*HF;" ;\ No grid"
#grid, "backcolor white ; place ";1003*WF;" ";293*HF;" ;\g"
#grid, "backcolor white ; up ; place ";900*WF;" ";300*HF;" ; down ; boxfilled ";1000*WF;" ";325*HF;" ; place ";905*WF;" ";320*HF;" ;\ Save work"
#grid, "backcolor white ; place ";1003*WF;" ";320*HF;" ;\s"
#grid, "backcolor white ; up ; place ";900*WF;" ";325*HF;" ; down ; boxfilled ";1000*WF;" ";350*HF;" ; place ";905*WF;" ";345*HF;" ;\Reload work"
#grid, "backcolor white ; place ";1003*WF;" ";345*HF;" ;\r"
#grid, "backcolor white ; up ; place ";900*WF;" ";350*HF;" ; down ; boxfilled ";1000*WF;" ";375*HF;" ; place ";903*WF;" ";370*HF;" ;\Work in back"
#grid, "backcolor white ; place ";1003*WF;" ";370*HF;" ;\a"
#grid, "backcolor darkcyan ; up ; place ";900*WF;" ";375*HF;" ; down ; boxfilled ";1000*WF;" ";400*HF;" ; place ";902*WF;" ";395*HF;" ;\ Write spline"
#grid, "backcolor white ; place ";1003*WF;" ";395*HF;" ;\v"
#grid, "backcolor green ; up ; place ";900*WF;" ";400*HF;" ; down ; boxfilled ";1000*WF;" ";425*HF;" ; place ";905*WF;" ";420*HF;" ;\ Write lathe"
#grid, "backcolor white ; place ";1004*WF;" ";420*HF;" ;\l"
#grid, "backcolor green ; up ; place ";900*WF;" ";425*HF;" ; down ; boxfilled ";1000*WF;" ";450*HF;" ; place ";905*WF;" ";445*HF;" ;\Wr latheCub"
#grid, "backcolor white ; place ";1003*WF;" ";445*HF;" ;\b"
#grid, "backcolor 0 175 0 ; up ; place ";900*WF;" ";450*HF;" ; down ; boxfilled ";1000*WF;" ";475*HF;" ; place ";907*WF;" ";470*HF;" ;\Close poly"
#grid, "backcolor white ; place ";1003*WF;" ";470*HF;" ;\k"
#grid, "backcolor green ; up ; place ";900*WF;" ";475*HF;" ; down ; boxfilled ";1000*WF;" ";500*HF;" ; place ";910*WF;" ";495*HF;" ;\Write poly"
#grid, "backcolor white ; place ";1003*WF;" ";495*HF;" ;\o"
#grid, "backcolor 0 175 0 ; up ; place ";900*WF;" ";500*HF;" ; down ; boxfilled ";1000*WF;" ";525*HF;" ; place ";905*WF;" ";520*HF;" ;\Close prism"
#grid, "font courier_new ";Font2;" bold ; backcolor white ; place ";1003*WF;" ";520*HF;" ;\i"
#grid, "font Arial ";Font2;" bold ; backcolor green ; up ; place ";900*WF;" ";525*HF;" ; down ; boxfilled ";1000*WF;" ";550*HF;" ; place ";905*WF;" ";545*HF;" ;\Write prism"
#grid, "backcolor white ; place ";1003*WF;" ";545*HF;" ;\p"
#grid, "backcolor 0 175 0 ; up ; place ";900*WF;" ";550*HF;" ; down ; boxfilled ";1000*WF;" ";575*HF;" ; place ";904*WF;" ";570*HF;" ;\Cl prismCub"
#grid, "backcolor white ; place ";1003*WF;" ";570*HF;" ;\u"
#grid, "backcolor green ; up ; place ";900*WF;" ";575*HF;" ; down ; boxfilled ";1000*WF;" ";600*HF;" ; place ";902*WF;" ";595*HF;" ;\Wr prismCub"
#grid, "backcolor white ; place ";1003*WF;" ";595*HF;" ;\c"
#grid, "backcolor white ; up ; place ";900*WF;" ";600*HF;" ; down ; boxfilled ";1000*WF;" ";625*HF;" ; place ";910*WF;" ";620*HF;" ;\Draw cubic"
#grid, "backcolor white ; place ";1003*WF;" ";613*HF;" ;\d"
#grid, "backcolor white ; up ; place ";900*WF;" ";625*HF;" ; down ; boxfilled ";1000*WF;" ";650*HF;
#grid, "backcolor white ; place ";1003*WF;" ";630*HF;" ;\1"
#grid, "backcolor white ; place ";1003*WF;" ";645*HF;" ;\2"
#grid, "backcolor white ; place ";1003*WF;" ";660*HF;" ;\0"

select case
case Snap=0 and Snap2=1
#grid, "backcolor white ; color red ; place ";903*WF;" ";645*HF;" ;\ ";0.125/HF;
#grid, "backcolor white ; color lightgray ; place ";930*WF;" ";645*HF;" ;\  ";0.25/HF
#grid, "backcolor white ; color lightgray ; place ";970*WF;" ";645*HF;" ;\Off"
case Snap=1 and Snap2=0
#grid, "backcolor white ; color lightgray ; place ";903*WF;" ";645*HF;" ;\ ";0.125/HF;
#grid, "backcolor white ; color red ; place ";930*WF;" ";645*HF;" ;\  ";0.25/HF
#grid, "backcolor white ; color lightgray ; place ";970*WF;" ";645*HF;" ;\Off"
case Snap=0 and Snap2=0
#grid, "backcolor white ; color lightgray ; place ";903*WF;" ";645*HF;" ;\ ";0.125/HF;
#grid, "backcolor white ; color lightgray ; place ";930*WF;" ";645*HF;" ;\  ";0.25/HF
#grid, "backcolor white ; color red ; place ";970*WF;" ";645*HF;" ;\Off"
end select
#grid, "color black ; backcolor red ; up ; place ";900*WF;" ";650*HF;" ; down ; boxfilled ";1000*WF;" ";675*HF;" ; place ";928*WF;" ";670*HF;" ;\ Exit"
#grid, "backcolor white ; place ";1003*WF;" ";675*HF;" ;\q"
#grid, "color black ; backcolor white ; up ; place ";900*WF;" ";675*HF;" ; down ; boxfilled ";1000*WF;" ";700*HF;" ; place ";908*WF;" ";695*HF;" ;\Lf Up Dn Rg"
#grid, "color darkgreen ; backcolor white ; place ";895*WF;" ";715*HF;" ;\(F1, F2, F3, F4)"
#grid, "color darkgreen ; backcolor white ; place ";895*WF;" ";730*HF;" ;\(F5, F6, F7, F8)"
#grid, "font Arial ";Font0;" ; backcolor white ; color black ; place ";20*WF;" ";720*HF;" ;\Press S (upper case) for fast save as 'Backup.txt'"

#grid, "backcolor red ; up ; place ";890*WF;" ";660*HF;" ; down ; boxfilled ";900*WF;" ";650*HF;" ; color black ; backcolor white ; font Arial ";Font0;" bold ; place ";879*WF;" ";660*HF;" ;\ 4"
#grid, "backcolor black ; up ; place ";890*WF;" ";670*HF;" ; down ; boxfilled ";900*WF;" ";660*HF;" ; color black ; backcolor white ; font Arial ";Font0;" bold ; place ";879*WF;" ";670*HF;" ;\ 5"
#grid, "backcolor yellow ; up ; place ";890*WF;" ";680*HF;" ; down ; boxfilled ";900*WF;" ";670*HF;" ; color black ; backcolor white ; font Arial ";Font0;" bold ; place ";879*WF;" ";680*HF;" ;\ 6"
#grid, "backcolor blue ; up ; place ";890*WF;" ";690*HF;" ; down ; boxfilled ";900*WF;" ";680*HF;" ; color black ; backcolor white ; font Arial ";Font0;" bold ; place ";879*WF;" ";690*HF;" ;\ 7"
#grid, "backcolor green ; up ; place ";890*WF;" ";700*HF;" ; down ; boxfilled ";900*WF;" ";690*HF;" ; color black ; backcolor white ; font Arial ";Font0;" bold ; place ";879*WF;" ";700*HF;" ;\ 8"

goto [Undo2]

[nextpoint]

#grid "when leftButtonDown [drawpoint]"
#grid "when mouseMove [writepos]"

wait

[writepos]
gosub [snapto]
#grid, "backcolor white ; place ";625*WF;" 0 ; color white ; boxfilled ";775*WF;" ";20*HF;
#grid, "color 0 0 255 ; place ";650*WF;" ";18*HF;" ; down ;\(";MouseX/(50*WF)-8*CenterY-1;" , "; (650*HF-MouseY)/(50*HF)-6*CenterX;")" 'afrund y her
goto [nextpoint]

[drawpoint]

if MouseX > 900*WF then
select case
case MouseY > 675*HF
goto [moveit]
case MouseY > 650*HF
goto [quit]
case MouseY > 625*HF
select case
case MouseX > 966*WF
Snap=0
Snap2=0
case MouseX > 933*WF
Snap=1
Snap2=0
case else
Snap=0
Snap2=1
end select
goto [drawgrid]
case MouseY > 600*HF
[pressedd]
Preview=1-Preview
#grid, "cls"
goto [drawgrid]
case MouseY > 575*HF
[pressedc]
PrismCubic=1
SubPrismCubic=0
Prism=0
SubPrism=0
Polygon=0
SubPoly=0
LatheCubic=0
Lathe=0
Spline=0
Plot=0
goto [makefile]
case MouseY > 550*HF
[pressedu]
PrismCubic=0
SubPrismCubic=1
XandY(Points+3,3)=1
Prism=0
SubPrism=0
Polygon=0
SubPoly=0
LatheCubic=0
Lathe=0
Spline=0
Plot=0
goto [Undo2]
case MouseY > 525*HF
[pressedp]
PrismCubic=0
SubPrismCubic=0
Prism=1
SubPrism=0
Polygon=0
SubPoly=0
LatheCubic=0
Lathe=0
Spline=0
Plot=0
goto [makefile]
case MouseY > 500*HF
[pressedi]
PrismCubic=0
SubPrismCubic=0
Prism=0
SubPrism=1
XandY(Points+1,3)=1
Polygon=0
SubPoly=0
LatheCubic=0
Lathe=0
Spline=0
Plot=0
goto [Undo2]
case MouseY > 475*HF
[pressedo]
PrismCubic=0
SubPrismCubic=0
Prism=0
SubPrism=0
Polygon=1
SubPoly=0
LatheCubic=0
Lathe=0
Spline=0
Plot=0
goto [makefile]
case MouseY > 450*HF
[pressedk]
PrismCubic=0
SubPrismCubic=0
Prism=0
SubPrism=0
Polygon=0
SubPoly=1
XandY(Points+1,3)=1
LatheCubic=0
Lathe=0
Spline=0
Plot=0
goto [Undo2]
case MouseY > 425*HF
[pressedb]
PrismCubic=0
SubPrismCubic=0
Prism=0
SubPrism=0
Polygon=0
SubPoly=0
LatheCubic=1
Lathe=0
Spline=0
Plot=0
goto [makefile]
case MouseY > 400*HF
[pressedl]
PrismCubic=0
SubPrismCubic=0
Prism=0
SubPrism=0
Polygon=0
SubPoly=0
LatheCubic=0
Lathe=1
Spline=0
Plot=0
goto [makefile]
case MouseY > 375*HF
[pressedv]
PrismCubic=0
SubPrismCubic=0
Prism=0
SubPrism=0
Polygon=0
SubPoly=0
LatheCubic=0
Lathe=0
Spline=1
Plot=0
goto [makefile]
case MouseY > 350*HF
[presseda]
WorkBackg = 1-WorkBackg
goto [readbackground]
case MouseY > 325*HF
[pressedr]
PrismCubic=0
SubPrismCubic=0
Prism=0
SubPrism=0
Polygon=0
SubPoly=0
LatheCubic=0
Lathe=0
Spline=0
Plot=0
goto [readpoints]
case MouseY > 300*HF
[presseds]
PrismCubic=0
SubPrismCubic=0
Prism=0
SubPrism=0
Polygon=0
SubPoly=0
LatheCubic=0
Lathe=0
Spline=0
Plot=1
goto [makefile]
case MouseY > 275*HF
goto [nogrid]
case MouseY > 250*HF
goto [wgrid]
case MouseY > 225*HF
goto [model]
case MouseY > 200*HF
[pressedy]
#grid, "cls"
CenterY = 1-CenterY
goto [drawgrid]
case MouseY > 175*HF
[pressedx]
#grid, "cls"
CenterX = 1-CenterX
goto [drawgrid]
case MouseY > 150*HF
Edit = 1
goto [drawgrid]
case MouseY > 125*HF
goto [erase]
case MouseY > 100*HF
goto [new]
case MouseY > 75*HF
goto [helpme]
end select
end if

if MouseX > 890*WF and MouseY >650*HF then
select case
case MouseY > 690*HF
[pressed8]
LineCol$="green"
case MouseY > 680*HF
[pressed7]
LineCol$="blue"
case MouseY > 670*HF
[pressed6]
LineCol$="yellow"
case MouseY > 660*HF
[pressed5]
LineCol$="black"
case MouseY > 650*HF
[pressed4]
LineCol$="red"
end select
goto [drawgrid]
end if

Points=Points+1

if Snap=1 or Snap2=1 then
gosub [snapto]
end if

if KeepX = 0 then      'Hvis pil op eller ned er trykket
XandY(Points,1)=MouseX
else
XandY(Points,1)=XandY(Points-1,1)
KeepX=0               'nulstil
end if
if KeepY = 0 then     ' Hvis pil hjre eller venstre er trykket
XandY(Points,2)=MouseY
else
XandY(Points,2)=XandY(Points-1,2)
KeepY=0               ' nulstil
end if

[Undo2]

if Points < 0 then
goto [new]                          'S vi ikke fr fejlmeddelelser ved at bruge Undo for meget
end if

if SubPrismCubic=1 then
FindSub=Points
Points=Points+3                     'Her skaber vi et ekstra punkt, som bliver en kopi af det, der skal lukkes
while XandY(FindSub,3)=0
FindSub = FindSub-1
wend
FindSub = FindSub+3
XandY(Points-2,1)=XandY(FindSub-2,1) 'PrismCount fandt vi lngere nede - et punkt, hvor subprisms skiller
XandY(Points-2,2)=XandY(FindSub-2,2)
XandY(Points-1,1)=XandY(FindSub-1,1) 'PrismCount fandt vi lngere nede - et punkt, hvor subprisms skiller
XandY(Points-1,2)=XandY(FindSub-1,2)
XandY(Points,1)=XandY(FindSub,1) 'PrismCount fandt vi lngere nede - et punkt, hvor subprisms skiller
XandY(Points,2)=XandY(FindSub,2)
SubPrismCubic=0 'reset                   'Marker for, om subprism er aktuelt, s vi ikke slber rundt p det gennem hele programmet
goto [skipline]
end if

if SubPrism=1 then
FindSub=Points                     'Her skaber vi et ekstra punkt, som bliver en kopi af det, der skal lukkes
Points=Points+1
while XandY(FindSub,3)=0
FindSub = FindSub-1
wend
FindSub = FindSub+1
XandY(Points,1)=XandY(FindSub,1) 'PrismCount fandt vi lngere nede - et punkt, hvor subprisms skiller
XandY(Points,2)=XandY(FindSub,2)
SubPrism=0 'reset                   'Marker for, om subprism er aktuelt, s vi ikke slber rundt p det gennem hele programmet
goto [skipline]
end if

if SubPoly=1 then
FindSub=Points
Points=Points+1                    'Her skaber vi et ekstra punkt, som bliver en kopi af det, der skal lukkes
while XandY(FindSub,3)=0
FindSub = FindSub-1
wend
FindSub = FindSub+1
XandY(Points,1)=XandY(FindSub,1) 'PolyCount fandt vi lngere nede - et punkt, hvor subpolys skiller
XandY(Points,2)=XandY(FindSub,2)
SubPoly=0 'reset                    'Marker for, om subpoly er aktuelt, s vi ikke slber rundt p det gennem hele programmet
goto [skipline]
end if

if Edit = 1 then
#grid, "size 5 ; font Arial 20 bold ; color green ; backcolor white ; place ";800*WF;" ";80*HF;" ;\EDIT"
#grid, "size 2 ; font Arial ";Font1;" bold ; color darkgreen ; backcolor white ; place ";400*WF;" ";725*HF;" ;\Click point to be edited                                                                   " 'Mange mellemrum for at overskrive gammel tekst
Edit = 2
goto [skipline]   ' ndret fra [nextpoint] for at bevare punkter ved Edit med Model-baggrund
end if

if Edit = 2 then
for editcheck=0 to Points-1
if abs (XandY(editcheck,1)-XandY(Points,1)) < 10 and abs (XandY(editcheck,2)-XandY(Points,2)) < 10 then 'Hvilket gammelt punkt er der nu klikket p? Sammenligner med alle indenfor 0.1 unit
#grid, "size 5 ; color green ; set "; XandY(editcheck,1); " "; XandY(editcheck,2) 'St en grn prik hvor punkt der skal rettes ligger
#grid, "size 2 ; font Arial ";Font1;" bold ; color darkgreen ; backcolor white ; place ";400*WF;" ";725*HF;" ;\Click new position for point"
Edit = 3 'Nu har vi fundet punktet blandt de tegnede og gemt det. Nste skridt er at vlge det nye punkt der skal erstatte det
Points=Points-1
goto [nextpoint]
end if
next editcheck 'Hvis der ikke findes matches med det nye punkt, tilfjes figuren en streg i stedet, men edit mode forbliver ON
end if

if Edit = 3 then
XandY(editcheck,1)=XandY(Points,1) 'Det gamle punkt udskiftes med det nye
XandY(editcheck,2)=XandY(Points,2)
Points=Points-1
Edit = 0
#grid, "cls"
goto [drawgrid]
end if

[skipline]

#grid, "size 4 ; color red ; set "; XandY(Points,1); " "; XandY(Points,2) 'St en rd prik hvor det nye punkt ligger

#grid, "font Arial ";Font2;" bold ; backcolor white ; place ";910*WF;" ";90*HF;" ;\ ";Points;"  /  ";500-Points  'FR: #grid, "font Arial ";Font2;" bold ; backcolor white ; place ";915*WF;" ";90*HF;" ;\ Left: ";500-Points

select case
case Snap=0 and Snap2=1
#grid, "backcolor white ; color red ; place ";903*WF;" ";645*HF;" ;\ ";0.125/HF;
#grid, "backcolor white ; color lightgray ; place ";930*WF;" ";645*HF;" ;\  ";0.25/HF
#grid, "backcolor white ; color lightgray ; place ";970*WF;" ";645*HF;" ;\Off"
case Snap=1 and Snap2=0
#grid, "backcolor white ; color lightgray ; place ";903*WF;" ";645*HF;" ;\ ";0.125/HF;
#grid, "backcolor white ; color red ; place ";930*WF;" ";645*HF;" ;\  ";0.25/HF
#grid, "backcolor white ; color lightgray ; place ";970*WF;" ";645*HF;" ;\Off"
case Snap=0 and Snap2=0
#grid, "backcolor white ; color lightgray ; place ";903*WF;" ";645*HF;" ;\ ";0.125/HF;
#grid, "backcolor white ; color lightgray ; place ";930*WF;" ";645*HF;" ;\  ";0.25/HF
#grid, "backcolor white ; color red ; place ";970*WF;" ";645*HF;" ;\Off"
end select

if WorkBackg=1 then
select case
case CuBack=0
for Back=2 to PointsB
#grid, "size 3 ; color ";BackCol$;" ; line "; Background(Back-1,1) ;" "; Background(Back-1,2);" ";Background(Back,1);" ";Background(Back,2)
#grid, "size 4 ; color black ; set "; Background(Back-1,1); " "; Background(Back-1,2) 'St en sort prik hvor punktet ligger
if Background(Back,3)=1 then                                                  'Subpoly her? S spring over
Back=Back+1
end if
next Back
case CuBack=1

t1 = 0
t2 = 1/3
t3 = 2/3
t4 = 1

for Back = 2 to PointsB-2  'A cubic curve needs four points, and here they are

x1 = Background(Back-1,1)
x2 = Background(Back,1)
x3 = Background(Back+1,1)
x4 = Background(Back+2,1)

y1 = Background(Back-1,2)
y2 = Background(Back,2)
y3 = Background(Back+1,2)
y4 = Background(Back+2,2)

Determinant = (t4^3)*(t3^2)*t2-(t3^3)*(t4^2)*t2-(t4^3)*(t2^2)*t3+(t2^3)*(t4^2)*t3+(t3^3)*(t2^2)*t4-(t2^3)*(t3^2)*t4-(t4^3)*(t3^2)*t1+(t3^3)*(t4^2)*t1+(t4^3)*(t1^2)*t3-(t1^3)*(t4^2)*t3-(t3^3)*(t1^2)*t4+(t1^3)*(t3^2)*t4+(t4^3)*(t2^2)*t1-(t2^3)*(t4^2)*t1-(t4^3)*(t1^2)*t2+(t1^3)*(t4^2)*t2+(t2^3)*(t1^2)*t4-(t1^3)*(t2^2)*t4-(t3^3)*(t2^2)*t1+(t2^3)*(t3^2)*t1+(t3^3)*(t1^2)*t2-(t1^3)*(t3^2)*t2-(t2^3)*(t1^2)*t3+(t1^3)*(t2^2)*t3

Felt1 = (t3^2)*t4 - (t4^2)*t3 + (t4^2)*t2 - (t2^2)*t4 - (t3^2)*t2 + (t2^2)*t3
Felt2 = (t4^2)*t3 - (t3^2)*t4 - (t4^2)*t1 + (t1^2)*t4 + (t3^2)*t1 - (t1^2)*t3
Felt3 = (t2^2)*t4 - (t4^2)*t2 + (t4^2)*t1 - (t1^2)*t4 - (t2^2)*t1 + (t1^2)*t2
Felt4 = (t3^2)*t2 - (t2^2)*t3 - (t3^2)*t1 + (t1^2)*t3 + (t2^2)*t1 - (t1^2)*t2
Felt5 = (t4^3)*t3 - (t3^3)*t4 - (t4^3)*t2 + (t2^3)*t4 + (t3^3)*t2 - (t2^3)*t3
Felt6 = (t3^3)*t4 - (t4^3)*t3 + (t4^3)*t1 - (t1^3)*t4 - (t3^3)*t1 + (t1^3)*t3
Felt7 = (t4^3)*t2 - (t2^3)*t4 - (t4^3)*t1 + (t1^3)*t4 + (t2^3)*t1 - (t1^3)*t2
Felt8 = (t2^3)*t3 - (t3^3)*t2 + (t3^3)*t1 - (t1^3)*t3 - (t2^3)*t1 + (t1^3)*t2
Felt9 = (t3^3)*(t4^2) - (t4^3)*(t3^2) + (t4^3)*(t2^2) - (t2^3)*(t4^2) - (t3^3)*(t2^2) + (t2^3)*(t3^2)
Felt10 = (t4^3)*(t3^2) - (t3^3)*(t4^2) - (t4^3)*(t1^2) + (t1^3)*(t4^2) + (t3^3)*(t1^2) - (t1^3)*(t3^2)
Felt11 = (t2^3)*(t4^2) - (t4^3)*(t2^2) + (t4^3)*(t1^2) - (t1^3)*(t4^2) - (t2^3)*(t1^2) + (t1^3)*(t2^2)
Felt12 = (t3^3)*(t2^2) - (t2^3)*(t3^2) - (t3^3)*(t1^2) + (t1^3)*(t3^2) + (t2^3)*(t1^2) - (t1^3)*(t2^2)
Felt13 = (t4^3)*(t3^2)*t2 - (t3^3)*(t4^2)*t2 - (t4^3)*(t2^2)*t3 + (t2^3)*(t4^2)*t3 + (t3^3)*(t2^2)*t4 - (t2^3)*(t3^2)*t4
Felt14 = (t3^3)*(t4^2)*t1 - (t4^3)*(t3^2)*t1 + (t4^3)*(t1^2)*t3 - (t1^3)*(t4^2)*t3 - (t3^3)*(t1^2)*t4 + (t1^3)*(t3^2)*t4
Felt15 = (t4^3)*(t2^2)*t1 - (t2^3)*(t4^2)*t1 - (t4^3)*(t1^2)*t2 + (t1^3)*(t4^2)*t2 + (t2^3)*(t1^2)*t4 - (t1^3)*(t2^2)*t4
Felt16 = (t2^3)*(t3^2)*t1 - (t3^3)*(t2^2)*t1 + (t3^3)*(t1^2)*t2 - (t1^3)*(t3^2)*t2 - (t2^3)*(t1^2)*t3 + (t1^3)*(t2^2)*t3

if Determinant = 0 then
notice "Can not draw curve. Stopping"
goto [nextpoint]
end if 'end if Determinant=0

CubackAx = Felt1/Determinant*x1 + Felt2/Determinant*x2 + Felt3/Determinant*x3 + Felt4/Determinant*x4
CubackAy = Felt1/Determinant*y1 + Felt2/Determinant*y2 + Felt3/Determinant*y3 + Felt4/Determinant*y4
CubackBx = Felt5/Determinant*x1 + Felt6/Determinant*x2 + Felt7/Determinant*x3 + Felt8/Determinant*x4
CubackBy = Felt5/Determinant*y1 + Felt6/Determinant*y2 + Felt7/Determinant*y3 + Felt8/Determinant*y4
CubackCx = Felt9/Determinant*x1 + Felt10/Determinant*x2 + Felt11/Determinant*x3 + Felt12/Determinant*x4
CubackCy = Felt9/Determinant*y1 + Felt10/Determinant*y2 + Felt11/Determinant*y3 + Felt12/Determinant*y4
CubackDx = Felt13/Determinant*x1 + Felt14/Determinant*x2 + Felt15/Determinant*x3 + Felt16/Determinant*x4
CubackDy = Felt13/Determinant*y1 + Felt14/Determinant*y2 + Felt15/Determinant*y3 + Felt16/Determinant*y4

Afstand = sqr((x3-x2)^2 + (y3-y2)^2) 'Find passende interval mellem punkter

for PlotB = t2 to t3 step 0.5/Afstand
xB = CubackAx*(PlotB^3) + CubackBx*(PlotB^2) + CubackCx*PlotB + CubackDx
yB = CubackAy*(PlotB^3) + CubackBy*(PlotB^2) + CubackCy*PlotB + CubackDy
#grid, "size 3 ; color ";BackCol$;" ; set ";xB;" ";yB
#grid, "size 4 ; color black ; set "; Background(Back-1,1); " "; Background(Back-1,2) 'St en rd prik hvor det nye punkt ligger
next PlotB

t1 = t1+1/3
t2 = t2+1/3
t3 = t3+1/3
t4 = t4+1/3

if Background(Back+2,3)=1 then                                                  'Cubic subpoly her (plus to points?) S spring over
Back=Back+3
end if

next Back

#grid, "flush" '  TJEK LIGE OM DENNE ER NDVENDIG

end select
end if ' end WorkBackg

if Preview<1 then
goto [linear]
end if

[preview]

t1 = 0
t2 = 1/3
t3 = 2/3
t4 = 1

for Curve = 2 to Points-2 step 1  'A cubic curve needs four points, and here they are

x1 = XandY(Curve-1,1)
x2 = XandY(Curve,1)
x3 = XandY(Curve+1,1)
x4 = XandY(Curve+2,1)

y1 = XandY(Curve-1,2)
y2 = XandY(Curve,2)
y3 = XandY(Curve+1,2)
y4 = XandY(Curve+2,2)

Determinant = (t4^3)*(t3^2)*t2-(t3^3)*(t4^2)*t2-(t4^3)*(t2^2)*t3+(t2^3)*(t4^2)*t3+(t3^3)*(t2^2)*t4-(t2^3)*(t3^2)*t4-(t4^3)*(t3^2)*t1+(t3^3)*(t4^2)*t1+(t4^3)*(t1^2)*t3-(t1^3)*(t4^2)*t3-(t3^3)*(t1^2)*t4+(t1^3)*(t3^2)*t4+(t4^3)*(t2^2)*t1-(t2^3)*(t4^2)*t1-(t4^3)*(t1^2)*t2+(t1^3)*(t4^2)*t2+(t2^3)*(t1^2)*t4-(t1^3)*(t2^2)*t4-(t3^3)*(t2^2)*t1+(t2^3)*(t3^2)*t1+(t3^3)*(t1^2)*t2-(t1^3)*(t3^2)*t2-(t2^3)*(t1^2)*t3+(t1^3)*(t2^2)*t3

Felt1 = (t3^2)*t4 - (t4^2)*t3 + (t4^2)*t2 - (t2^2)*t4 - (t3^2)*t2 + (t2^2)*t3
Felt2 = (t4^2)*t3 - (t3^2)*t4 - (t4^2)*t1 + (t1^2)*t4 + (t3^2)*t1 - (t1^2)*t3
Felt3 = (t2^2)*t4 - (t4^2)*t2 + (t4^2)*t1 - (t1^2)*t4 - (t2^2)*t1 + (t1^2)*t2
Felt4 = (t3^2)*t2 - (t2^2)*t3 - (t3^2)*t1 + (t1^2)*t3 + (t2^2)*t1 - (t1^2)*t2
Felt5 = (t4^3)*t3 - (t3^3)*t4 - (t4^3)*t2 + (t2^3)*t4 + (t3^3)*t2 - (t2^3)*t3
Felt6 = (t3^3)*t4 - (t4^3)*t3 + (t4^3)*t1 - (t1^3)*t4 - (t3^3)*t1 + (t1^3)*t3
Felt7 = (t4^3)*t2 - (t2^3)*t4 - (t4^3)*t1 + (t1^3)*t4 + (t2^3)*t1 - (t1^3)*t2
Felt8 = (t2^3)*t3 - (t3^3)*t2 + (t3^3)*t1 - (t1^3)*t3 - (t2^3)*t1 + (t1^3)*t2
Felt9 = (t3^3)*(t4^2) - (t4^3)*(t3^2) + (t4^3)*(t2^2) - (t2^3)*(t4^2) - (t3^3)*(t2^2) + (t2^3)*(t3^2)
Felt10 = (t4^3)*(t3^2) - (t3^3)*(t4^2) - (t4^3)*(t1^2) + (t1^3)*(t4^2) + (t3^3)*(t1^2) - (t1^3)*(t3^2)
Felt11 = (t2^3)*(t4^2) - (t4^3)*(t2^2) + (t4^3)*(t1^2) - (t1^3)*(t4^2) - (t2^3)*(t1^2) + (t1^3)*(t2^2)
Felt12 = (t3^3)*(t2^2) - (t2^3)*(t3^2) - (t3^3)*(t1^2) + (t1^3)*(t3^2) + (t2^3)*(t1^2) - (t1^3)*(t2^2)
Felt13 = (t4^3)*(t3^2)*t2 - (t3^3)*(t4^2)*t2 - (t4^3)*(t2^2)*t3 + (t2^3)*(t4^2)*t3 + (t3^3)*(t2^2)*t4 - (t2^3)*(t3^2)*t4
Felt14 = (t3^3)*(t4^2)*t1 - (t4^3)*(t3^2)*t1 + (t4^3)*(t1^2)*t3 - (t1^3)*(t4^2)*t3 - (t3^3)*(t1^2)*t4 + (t1^3)*(t3^2)*t4
Felt15 = (t4^3)*(t2^2)*t1 - (t2^3)*(t4^2)*t1 - (t4^3)*(t1^2)*t2 + (t1^3)*(t4^2)*t2 + (t2^3)*(t1^2)*t4 - (t1^3)*(t2^2)*t4
Felt16 = (t2^3)*(t3^2)*t1 - (t3^3)*(t2^2)*t1 + (t3^3)*(t1^2)*t2 - (t1^3)*(t3^2)*t2 - (t2^3)*(t1^2)*t3 + (t1^3)*(t2^2)*t3

if Determinant = 0 then
notice "Can not draw curve. Stopping"
goto [nextpoint]
end if 'end if Determinant=0

CubicAx = Felt1/Determinant*x1 + Felt2/Determinant*x2 + Felt3/Determinant*x3 + Felt4/Determinant*x4
CubicAy = Felt1/Determinant*y1 + Felt2/Determinant*y2 + Felt3/Determinant*y3 + Felt4/Determinant*y4
CubicBx = Felt5/Determinant*x1 + Felt6/Determinant*x2 + Felt7/Determinant*x3 + Felt8/Determinant*x4
CubicBy = Felt5/Determinant*y1 + Felt6/Determinant*y2 + Felt7/Determinant*y3 + Felt8/Determinant*y4
CubicCx = Felt9/Determinant*x1 + Felt10/Determinant*x2 + Felt11/Determinant*x3 + Felt12/Determinant*x4
CubicCy = Felt9/Determinant*y1 + Felt10/Determinant*y2 + Felt11/Determinant*y3 + Felt12/Determinant*y4
CubicDx = Felt13/Determinant*x1 + Felt14/Determinant*x2 + Felt15/Determinant*x3 + Felt16/Determinant*x4
CubicDy = Felt13/Determinant*y1 + Felt14/Determinant*y2 + Felt15/Determinant*y3 + Felt16/Determinant*y4

Afstand = sqr((x3-x2)^2 + (y3-y2)^2) 'Find passende interval mellem punkter

for PlotT = t2 to t3 step 0.5/Afstand
xA = CubicAx*(PlotT^3) + CubicBx*(PlotT^2) + CubicCx*PlotT + CubicDx
yA = CubicAy*(PlotT^3) + CubicBy*(PlotT^2) + CubicCy*PlotT + CubicDy
#grid, "size 3 ; color ";LineCol$;" ; set ";xA;" ";yA
#grid, "size 4 ; color red ; set "; XandY(Curve-1,1); " "; XandY(Curve-1,2) 'St en rd prik hvor det nye punkt ligger
next PlotT

t1 = t1+1/3
t2 = t2+1/3
t3 = t3+1/3
t4 = t4+1/3

if XandY(Curve+2,3)=1 then                                                  'Cubic subpoly her (plus to points?) S spring over
Curve=Curve+3
end if

next Curve

#grid, "flush" '  TJEK LIGE OM DENNE ER NDVENDIG

goto [nextpoint]

[linear]

select case Points
case 0, -1
case 1
#grid, "backcolor white ; color 0 0 255 ; place ";520*WF;" ";18*HF;" ; down ;\(";XandY(1,1)/(50*WF)-8*CenterY-1;" , ";(650*HF-XandY(1,2))/(50*HF)-6*CenterX;")"
case else 'Hvis dette ikke er frste tegnede punkt, s tegn en streg mellem forrige og dette

for Streg = 2 to Points

#grid, "size 2 ; color ";LineCol$;" ; line "; XandY(Streg-1,1) ;" "; XandY(Streg-1,2);" ";XandY(Streg,1);" ";XandY(Streg,2)
#grid, "size 4 ; color red ; set "; XandY(Streg-1,1); " "; XandY(Streg-1,2) 'St en rd prik hvor det nye punkt ligger

Xpos1 = XandY(Points,1)/(50*WF)-8*CenterY-1
Ypos1 = (650*HF-XandY(Points,2))/(50*HF)-6*CenterX
Xpos0 = XandY(Points-1,1)/(50*WF)-8*CenterY-1
Ypos0 = (650*HF-XandY(Points-1,2))/(50*HF)-6*CenterX

Distance = sqr((Xpos1-Xpos0)^2 + (Ypos1-Ypos0)^2)
if Distance = 0 then
Points = Points-1
notice "You have clicked the same point twice"
goto [nextpoint]
end if
Distance$ = using("##.##",Distance)

#grid, "backcolor white ; color white ; place ";400*WF;" 0 ; down ; boxfilled ";1020*WF;" ";22*HF; ' sletter alt tidligere
#grid, "font Arial ";Font2;" bold ; backcolor white ; color 200 200 255 ; place ";400*WF;" ";18*HF;" ; down ;\(";Xpos0;" , ";Ypos0;")"
if Xpos1=Xpos0 or Ypos1=Ypos0 or abs(Xpos1-Xpos0)=abs(Ypos1-Ypos0) then
#grid, "backcolor white ; color 0 175 0 ; place ";520*WF;" ";18*HF;" ; down ;\(";Xpos1;" , ";Ypos1;")"
else
#grid, "backcolor white ; color 125 125 255 ; place ";520*WF;" ";18*HF;" ; down ;\(";Xpos1;" , ";Ypos1;")"
end if
#grid, "backcolor white ; color lightgray ; place ";790*WF;" ";18*HF;" ; down ;\ Distance ";Distance$

if Xpos1<>Xpos0 then
AngRad=ATN((Ypos1-Ypos0)/(Xpos1-Xpos0))
AngDeg=abs(AngRad*180/3.14159265)
else
AngDeg=90
end if
#grid, "backcolor white ; color lightgray ; place ";910*WF;" ";18*HF;" ; down ;\ Angle ";using("##.##",AngDeg)

if XandY(Streg,3)=1 then                                                  'Subpoly her? S spring over
Streg=Streg+1
end if

next Streg

end select

#grid, "flush"

goto [nextpoint]

[makefile]

if Plot=1 then
filedialog "Save work file", "*.txt", WorkSave$
[backup]
open WorkSave$ for output as #o
for Count=0 to Points-1
print #o, XandY(Count,1);" , ";XandY(Count,2);" , ";XandY(Count,3);" , ";
next Count
print #o, XandY(Points,1);" , ";XandY(Points,2);" , ";XandY(Points,3);                              'Vi m hverken starte eller slutte med komma. s speciel linie til slutning
close #o
#grid, "size 2 ; font Arial ";Font1;" bold ; color lightgray ; backcolor white ; place ";400*WF;" ";725*HF;" ;\Work is saved to file.                                                            " 'mange mellemrum for at overskrive gammel tekst
goto [nextpoint]
end if
open "POVpoints.txt" for append as #p
select case
case Spline=1
print #p, "spline {";Points;", ";
case Lathe=1
print #p, "lathe {linear_spline ";Points;", ";
case LatheCubic=1
print #p, "lathe {cubic_spline ";Points+3;", <";XandY(Points-2,1)/(50*WF)-8*CenterY-1;",";(650*HF-XandY(Points-2,2))/(50*HF)-6*CenterX;">,<";XandY(Points-1,1)/(50*WF)-8*CenterY-1;",";(650*HF-XandY(Points-1,2))/(50*HF)-6*CenterX;">,<";XandY(Points,1)/(50*WF)-8*CenterY-1;",";(650*HF-XandY(Points,2))/(50*HF)-6*CenterX;">,";
case Polygon=1
print #p, "polygon {";Points;", ";
case Prism=1
print #p, "prism {linear_spline 0, 1, ";Points;", ";
case PrismCubic=1
print #p, "prism {cubic_spline 0, 1, ";Points;", ";
end select

for Count=1 to Points-1
print #p, "<";XandY(Count,1)/(50*WF)-8*CenterY-1;",";(650*HF-XandY(Count,2))/(50*HF)-6*CenterX;">,";
next Count
print #p, "<";XandY(Points,1)/(50*WF)-8*CenterY-1;",";(650*HF-XandY(Points,2))/(50*HF)-6*CenterX;">}" 'Den sidste skrives uden komma efter og med tuborghat
close #p

'...og samme punkter kopieret direkte til Udklipsholder:

open "Skrivebord" for text as #t 'Denne lille rutine bner kortvarigt et textvindue, s vi kan f spline-vrdierne kopieret til Udklipsholder
select case
case Spline=1
print #t, "spline {";Points;", ";
case Lathe=1
print #t, "lathe {linear_spline ";Points;", ";
case LatheCubic=1
print #t, "lathe {cubic_spline ";Points+3;", <";XandY(Points-2,1)/(50*WF)-8*CenterY-1;",";(650*HF-XandY(Points-2,2))/(50*HF)-6*CenterX;">,<";XandY(Points-1,1)/(50*WF)-8*CenterY-1;",";(650*HF-XandY(Points-1,2))/(50*HF)-6*CenterX;">,<";XandY(Points,1)/(50*WF)-8*CenterY-1;",";(650*HF-XandY(Points,2))/(50*HF)-6*CenterX;">,";
case Polygon=1
print #t, "polygon {";Points;", ";
case Prism=1
print #t, "prism {linear_spline 0, 1, ";Points;", ";
case PrismCubic=1
print #t, "prism {cubic_spline 0, 1, ";Points;", ";
end select

for Count=1 to Points-1
print #t, "<";XandY(Count,1)/(50*WF)-8*CenterY-1;",";(650*HF-XandY(Count,2))/(50*HF)-6*CenterX;">,";
next Count
print #t, "<";XandY(Points,1)/(50*WF)-8*CenterY-1;",";(650*HF-XandY(Points,2))/(50*HF)-6*CenterX;">}" 'Den sidste skrives uden komma efter og med tuborghat
print #t, "!selectall"
print #t, "!copy"
close #t

select case
case Spline=1
#grid, "size 2 ; font Arial ";Font1;" bold ; color lightgray ; backcolor white ; place ";400*WF;" ";725*HF;" ;\Spline written to Clipboard and to file: POVpoints.txt        "
case Lathe=1
#grid, "size 2 ; font Arial ";Font1;" bold ; color lightgray ; backcolor white ; place ";400*WF;" ";725*HF;" ;\Lathe written to Clipboard and to file: POVpoints.txt         "
case LatheCubic=1
#grid, "size 2 ; font Arial ";Font1;" bold ; color lightgray ; backcolor white ; place ";400*WF;" ";725*HF;" ;\Cubic lathe written to Clipboard and to file: POVpoints.txt   "
case Polygon=1
#grid, "size 2 ; font Arial ";Font1;" bold ; color lightgray ; backcolor white ; place ";400*WF;" ";725*HF;" ;\Polygon written to Clipboard and to file: POVpoints.txt       "
case Prism=1
#grid, "size 2 ; font Arial ";Font1;" bold ; color lightgray ; backcolor white ; place ";400*WF;" ";725*HF;" ;\Prism written to Clipboard and to file: POVpoints.txt         "
case PrismCubic=1
#grid, "size 2 ; font Arial ";Font1;" bold ; color lightgray ; backcolor white ; place ";400*WF;" ";725*HF;" ;\Cubic prism written to Clipboard and to file: POVpoints.txt   "
end select

goto [background] 'ndret fra [nextpoint] for at bevare Model background ved brug af Write (se verst)

[quit]

open "Settings.txt" for output as #s
print #s, WhiteGrid
print #s, NoGrid
print #s, Snap
print #s, Snap2
print #s, CenterX
print #s, CenterY
print #s, LineCol$
print #s, BackCol$
close #s
close #grid

stop

[new]

close #grid
goto [reset]

[model]

UseModel=1-UseModel
if UseModel = 0 then
#grid, "cls"
else
filedialog "Open bitmap for tracing", "*.bmp", Bitmap$
if Bitmap$="" then
notice "No file was chosen."
UseModel=0
goto [nextpoint]
end if
end if
goto [background]

[wgrid]

WhiteGrid = 1-WhiteGrid
if WhiteGrid = 1 then
NoGrid = 0
Snap = 0
Snap2 = 0
#grid, "backcolor white"
end if
goto [drawgrid]

[nogrid]

NoGrid = 1-NoGrid
if NoGrid = 1 then
WhiteGrid = 0
Snap = 0
Snap2 = 0
else
Snap = 0
Snap2 = 1
end if
goto [drawgrid]

[erase]

close #grid
Erase = 1
XandY(Points,1)=0
XandY(Points,2)=0
XandY(Points,3)=0
Points = Points-1
goto [undo1]

[gridcolor]

select case
case (WhiteGrid=1) and (Snap=0) and (Snap2=0)
GridCol$="white"
case (WhiteGrid=1) and (Snap2=1)
GridCol$="pink"
case (WhiteGrid=1) and (Snap=1)
GridCol$="pink"
case (WhiteGrid=0) and (Snap2=1)
GridCol$="darkpink"
case (WhiteGrid=0) and (Snap=1)
GridCol$="darkpink"
case else
GridCol$="blue"
end select
return

[snapto]

if Snap2 = 1 and Snap = 0 then
Xval = MouseX-(100*int(MouseX/100))
select case
case Xval>96.875
MouseX=MouseX-Xval+100
case Xval>90.625
MouseX=MouseX-Xval+93.75
case Xval>84.375
MouseX=MouseX-Xval+87.5
case Xval>78.125
MouseX=MouseX-Xval+81.25
case Xval>71.875
MouseX=MouseX-Xval+75
case Xval>65.625
MouseX=MouseX-Xval+68.75
case Xval>59.375
MouseX=MouseX-Xval+62.5
case Xval>53.125
MouseX=MouseX-Xval+56.25
case Xval>46.875
MouseX=MouseX-Xval+50
case Xval>40.625
MouseX=MouseX-Xval+43.75
case Xval>34.375
MouseX=MouseX-Xval+37.5
case Xval>28.125
MouseX=MouseX-Xval+31.25
case Xval>21.875
MouseX=MouseX-Xval+25
case Xval>15.625
MouseX=MouseX-Xval+18.75
case Xval>9.375
MouseX=MouseX-Xval+12.5
case Xval>3.125
MouseX=MouseX-Xval+6.25
case else
MouseX=MouseX-Xval
end select

Yval = MouseY-(100*int(MouseY/100))
select case
case Yval>96.875
MouseY=MouseY-Yval+100
case Yval>90.625
MouseY=MouseY-Yval+93.75
case Yval>84.375
MouseY=MouseY-Yval+87.5
case Yval>78.125
MouseY=MouseY-Yval+81.25
case Yval>71.875
MouseY=MouseY-Yval+75
case Yval>65.625
MouseY=MouseY-Yval+68.75
case Yval>59.375
MouseY=MouseY-Yval+62.5
case Yval>53.125
MouseY=MouseY-Yval+56.25
case Yval>46.875
MouseY=MouseY-Yval+50
case Yval>40.625
MouseY=MouseY-Yval+43.75
case Yval>34.375
MouseY=MouseY-Yval+37.5
case Yval>28.125
MouseY=MouseY-Yval+31.25
case Yval>21.875
MouseY=MouseY-Yval+25
case Yval>15.625
MouseY=MouseY-Yval+18.75
case Yval>9.375
MouseY=MouseY-Yval+12.5
case Yval>3.125
MouseY=MouseY-Yval+6.25
case else
MouseY=MouseY-Yval
end select
return

end if

if Snap = 1 and Snap2 = 0 then

Xval = MouseX-(100*int(MouseX/100))
select case
case Xval>93.75
MouseX=MouseX-Xval+100
case Xval>81.25
MouseX=MouseX-Xval+87.5
case Xval>68.75
MouseX=MouseX-Xval+75
case Xval>56.25
MouseX=MouseX-Xval+62.5
case Xval>43.75
MouseX=MouseX-Xval+50
case Xval>31.25
MouseX=MouseX-Xval+37.5
case Xval>18.75
MouseX=MouseX-Xval+25
case Xval>6.25
MouseX=MouseX-Xval+12.5
case else
MouseX=MouseX-Xval
end select

Yval = MouseY-(100*int(MouseY/100))
select case
case Yval>93.75
MouseY=MouseY-Yval+100
case Yval>81.25
MouseY=MouseY-Yval+87.5
case Yval>68.75
MouseY=MouseY-Yval+75
case Yval>56.25
MouseY=MouseY-Yval+62.5
case Yval>43.75
MouseY=MouseY-Yval+50
case Yval>31.25
MouseY=MouseY-Yval+37.5
case Yval>18.75
MouseY=MouseY-Yval+25
case Yval>6.25
MouseY=MouseY-Yval+12.5
case else
MouseY=MouseY-Yval
end select

return

else

return

end if

[readpoints]

filedialog "Open work file", "*.txt", WorkName$

if WorkName$="" then
notice "No file was chosen."
WorkBackg=0
goto [nextpoint]
end if

[loadBackup]
open WorkName$ for input as #d
Points = -1
dim XandY(500,3)

[LseLoop]
Points = Points+1
input #d, XandY(Points,1)
input #d, XandY(Points,2)
input #d, XandY(Points,3)
if eof(#d) = 0 then [LseLoop]
close #d
goto [background]

[readbackground]

if WorkBackg=1 then
filedialog "Open work file", "*.txt", WorkName$

if WorkName$="" then
notice "No file was chosen."
WorkBackg=0
goto [nextpoint]
end if

[backupInBack]
open WorkName$ for input as #b
PointsB = -1
dim Background(500,3)

[BackgroundLoop]
PointsB = PointsB+1
input #b, Background(PointsB,1)
input #b, Background(PointsB,2)
input #b, Background(PointsB,3)
if eof(#b) = 0 then [BackgroundLoop]
close #b
#grid, "cls"
end if
goto [background]

[letter]

pressed$ = Inkey$
select case pressed$
case "h","H"
goto [helpme]
case "n","N"
goto [new]
case "x","X"
goto [pressedx]
case "y","Y"
goto [pressedy]
case "d" 'cubic curves
goto [pressedd]
case "D"
CuBack=1-CuBack
#grid, "cls"
goto [drawgrid]
goto [pressedD]
case "z","Z"
goto [erase]
case "e","E"
Edit = 1
goto [drawgrid]
case "m"
goto [model]
case "w","W"
goto [wgrid]
case "g","G"
goto [nogrid]
case "s"
goto [presseds]
case "r"
goto [pressedr]
case "a"
goto [presseda] 'work as background
case "v","V"
goto [pressedv] 'spline
case "l","L"
goto [pressedl] 'lathe
case "b","B"
goto [pressedb] 'lathe cubic
case "o","O"
goto [pressedo] 'polygon
case "k","K"
goto [pressedk] 'subpoly
case "p","P"
goto [pressedp] 'prism
case "i","I"
goto [pressedi] 'subprism
case "c","C"  'prismcubic
goto [pressedc]
case "u","U" 'subprismcubic
goto [pressedu]
case "S"
WorkSave$="Backup.txt"
goto [backup]
case "M"
files DefaultDir$, "\Model.bmp", infoM$() 'Vi checker om filen "Model.txt" findes
if val(infoM$(0,0)) = 0 then
notice "The file Model.bmp is not found in your PointWriter folder."
UseModel=0
goto [nextpoint]
end if
UseModel=1
Bitmap$="Model.bmp"
goto [loadModel]
case "R"
files DefaultDir$, "\Backup.txt", infoB$() 'Vi checker om filen "Backup.txt" findes
if val(infoB$(0,0)) = 0 then
notice "The file Backup.txt is not found in your PointWriter folder."
goto [nextpoint]
end if
WorkName$="Backup.txt"
goto [loadBackup]
case "A"
files DefaultDir$, "\Backup.txt", infoB$() 'Vi checker om filen "Backup.txt" findes
if val(infoB$(0,0)) = 0 then
notice "The file Backup.txt is not found in your PointWriter folder."
WorkBackg=0
goto [nextpoint]
end if
WorkBackg=1
WorkName$="Backup.txt"
goto [backupInBack]
case "2"
Snap=1
Snap2=0
goto [drawgrid]
case "1"
Snap=0
Snap2=1 'Prcis Snap on
goto [drawgrid]
case "0"
Snap=0
Snap2=0 'Prcis Snap off
goto [drawgrid] 'Disse genveje er for liniefarven
case "3"
LineCol$="darkgray" 'Denne genvej fr kun tastatur
goto [drawgrid]
case "4"
goto [pressed4]
case "5"
goto [pressed5]
case "6"
goto [pressed6]
case "7"
goto [pressed7]
case "8"
goto [pressed8]
case "9"
LineCol$="pink" 'Denne genvej fr kun tastatur
goto [drawgrid]

case "#" 'Disse genveje er for Work in Back (kun tastatur)
BackCol$="darkgray"
goto [drawgrid]
case ""
BackCol$="red"
goto [drawgrid]
case "%"
BackCol$="black"
goto [drawgrid]
case "&"
BackCol$="yellow"
goto [drawgrid]
case "/"
BackCol$="blue"
goto [drawgrid]
case "("
BackCol$="green"
goto [drawgrid]
case ")"
BackCol$="pink"
goto [drawgrid]
case "q","Q"      'quit
goto [quit]
end select

Up$ = chr$(_VK_UP)
Down$ = chr$(_VK_DOWN)
Rig$ = chr$(_VK_RIGHT)
Lef$ = chr$(_VK_LEFT)
ScrUp$ = chr$(_VK_F2)
ScrDn$ = chr$(_VK_F3)
ScrLf$ = chr$(_VK_F1)
ScrRg$ = chr$(_VK_F4)
Scr1Up$ = chr$(_VK_F6)
Scr1Dn$ = chr$(_VK_F7)
Scr1Lf$ = chr$(_VK_F5)
Scr1Rg$ = chr$(_VK_F8)
Key$ = left$(Inkey$,2)

select case right$(Key$,1)
case Up$
KeepX=1
case Down$
KeepX=1
case Rig$
KeepY=1
case Lef$
KeepY=1
case ScrUp$
gosub [moveup]
case ScrDn$
gosub [movedn]
case ScrLf$
gosub [movelf]
case ScrRg$
gosub [moverg]
case Scr1Up$
gosub [move1up]
case Scr1Dn$
gosub [move1dn]
case Scr1Lf$
gosub [move1lf]
case Scr1Rg$
gosub [move1rg]
end select

goto [drawgrid]

[moveit]
select case
case MouseX < 925*WF
gosub [movelf]
case MouseX < 950*WF
gosub [moveup]
case MouseX < 975*WF
gosub [movedn]
case MouseX < 1000*WF
gosub [moverg]
end select

goto [drawgrid]

[moveup] 'Disse 4 flytter 0.1 enhed i hver retning
for MoveU = 1 to Points
XandY(MoveU,2) = XandY(MoveU,2)-5*HF
next MoveU
#grid, "cls"
return

[movedn]
for MoveD = 1 to Points
XandY(MoveD,2) = XandY(MoveD,2)+5*HF
next MoveD
#grid, "cls"
return

[movelf]
for MoveL = 1 to Points
XandY(MoveL,1) = XandY(MoveL,1)-5*WF
next MoveL
#grid, "cls"
return

[moverg]
for MoveR = 1 to Points
XandY(MoveR,1) = XandY(MoveR,1)+5*WF
next MoveR
#grid, "cls"
return

[move1up] 'Disse 4 flytter en hel enhed i hver retning
for MoveU = 1 to Points
XandY(MoveU,2) = XandY(MoveU,2)-50*HF
next MoveU
#grid, "cls"
return

[move1dn]
for MoveD = 1 to Points
XandY(MoveD,2) = XandY(MoveD,2)+50*HF
next MoveD
#grid, "cls"
return

[move1lf]
for MoveL = 1 to Points
XandY(MoveL,1) = XandY(MoveL,1)-50*WF
next MoveL
#grid, "cls"
return

[move1rg]
for MoveR = 1 to Points
XandY(MoveR,1) = XandY(MoveR,1)+50*WF
next MoveR
#grid, "cls"
return

[helpme]
files DefaultDir$, "\PointWriterHelp.txt", infoH$() 'Vi checker om filen "PointWriterHelp.txt" findes
if val(infoH$(0,0)) = 0 then
notice "The file PointWriterHelp.txt is not found in your PointWriter folder."
goto [nextpoint]
end if
RUN "NOTEPAD.EXE PointWriterHelp.txt"
goto [drawgrid]


